local addonName, L = ...;
--[[
	 Most important information for Spectated War Games:
		UnitIDs: 
			spectatedaX
			spectatedbX
		TeamIDs: (e.g. CommentatorGetNumPlayers(teamID))
			1 = TeamB (spectatedbX)
			2 = TeamA (spectatedaX)
		factionIDs: (e.g. for GetBattlefieldWinner())
			 0 = TeamB (Green Team)
			 1 = TeamA (Gold Team)
]]
ArenaLiveSpectator.defaults = {
	["Broadcast"] = true,
	["FirstLogin"] = true,
	["FollowTarget"] = true,
	["HideTargetFrames"] = true,
	["PlayMode"] = 3,
	["ShowScoreBoard"] = true,
	["Version"] = "3.1.0b",
	["ImportantMessageFrame"] = {
		["NumMaxMessages"] = 2,
	},
	["TeamA"] = {
		["Name"] = "Gold Team",
		["Leader"] = "",
		["Score"] = 0,
		["Colour"] = { 1, 0.83, 0, 1 }, -- Gold Team (old blue 0, 0.5, 1, 1)
	},
	["TeamB"] = {
		["Name"] = "Green Team",
		["Leader"] = "",
		["Score"] = 0,
		["Colour"] = { 0.39, 0.71, 0.33, 1 }, -- Green Team (old: red 1, 0.19, 0, 1)
	},
	["MatchStatistic"] = {
	},
	["NicknameDatabase"] = {
	},
	["FrameMover"] = {
		["FrameLock"] = true,
	},
	["Cooldown"] =	{
		["ShowText"] = true,
		["StaticSize"] = false,
		["TextSize"] = 8,
	},
	["CCIndicator"] =	{
		["Priorities"] = {
			["defCD"] = 9,
			["offCD"] = 3,
			["stun"] = 8,
			["silence"] = 7,
			["crowdControl"] = 6,
			["root"] = 5,
			["disarm"] = 4,
			["usefulBuffs"] = 0,
			["usefulDebuffs"] = 0,
		},
	},
	["TargetFrame"] = {
		["UnitFrame"] = {
			["Enabled"] = true,
			["TooltipMode"] = "Never",
			["Scale"] = 1,
		},
		["HealthBar"] = {
			["ColourMode"] = "class",
			["ShowHealPrediction"] = true,
			["ShowAbsorb"] = true,
		},
		["HealthBarText"] = {
			["BarText"] = "%CURR_SHORT% (%PERCENT_SHORT%%)",
			["FontObject"] = "ArenaLiveFont_StatusBarTextSmall",
			["ShowDeadOrGhost"] = true,
			["ShowDisconnect"] = true,
		},
		["PowerBar"] = {
		},
		["PowerBarText"] = {
			["BarText"] = "%CURR_SHORT% (%PERCENT_SHORT%%)",
			["FontObject"] = "ArenaLiveFont_StatusBarTextSmall",
		},
		["Portrait"] = {
			["Type"] = "class",
		},
		["NameText"] = {
			["ColourMode"] = "none",
			["FontObject"] = "ArenaLiveFont_Name",
		},
		["CCIndicator"] = {
			["Enabled"] = true,
		},
		["CastBar"] = {
			["Enabled"] = true,
		},
		["CastHistory"] = {
			["Enabled"] = true,
			["Size"] = 21,
			["Direction"] = "RIGHT",
			["IconDuration"] = 10,
			["MaxIcons"] = 9,
		},
		["Aura"] = {
			["Enabled"] = true,
			["MaxShownBuffs"] = 8,
			["MaxShownDebuffs"] = 16,
			["AurasPerRow"] = 8,
			["NormalIconSize"] = 26,
			["LargeIconSize"] = 26,
			["GrowRTL"] = false,
			["GrowUpwards"] = false,
			["ShowOnlyPlayerDebuffs"] = false,
			["OnlyShowRaidBuffs"] = false,
			["OnlyShowDispellableDebuffs"] = false,
			["SpectatorFilter"] = true,
		},
	},
	["TargetTargetFrame"] = {
		["UnitFrame"] = {
			["Enabled"] = true,
			["TooltipMode"] = "Never",
			["Scale"] = 1,
		},
		["HealthBar"] = {
			["ColourMode"] = "class",
			["ShowHealPrediction"] = true,
			["ShowAbsorb"] = true,
		},
		["HealthBarText"] = {
			["BarText"] = "%CURR_SHORT% (%PERCENT_SHORT%%)",
			["FontObject"] = "ArenaLiveFont_StatusBarTextSmall",
			["ShowDeadOrGhost"] = true,
			["ShowDisconnect"] = true,
		},
		["PowerBar"] = {
		},
		["PowerBarText"] = {
			["BarText"] = "%CURR_SHORT% (%PERCENT_SHORT%%)",
			["FontObject"] = "ArenaLiveFont_StatusBarTextSmall",
		},
		["Portrait"] = {
			["Type"] = "class",
		},
		["NameText"] = {
			["ColourMode"] = "none",
			["FontObject"] = "ArenaLiveFont_Name",
		},
		["CCIndicator"] = {
			["Enabled"] = true,
		},
		["CastBar"] = {
			["Enabled"] = true,
		},
		["CastHistory"] = {
			["Enabled"] = true,
			["Size"] = 21,
			["Direction"] = "LEFT",
			["IconDuration"] = 10,
			["MaxIcons"] = 9,
		},
		["Aura"] = {
			["Enabled"] = true,
			["MaxShownBuffs"] = 8,
			["MaxShownDebuffs"] = 16,
			["AurasPerRow"] = 8,
			["NormalIconSize"] = 26,
			["LargeIconSize"] = 26,
			["GrowRTL"] = true,
			["GrowUpwards"] = false,
			["ShowOnlyPlayerDebuffs"] = false,
			["OnlyShowRaidBuffs"] = false,
			["OnlyShowDispellableDebuffs"] = false,
			["SpectatorFilter"] = true,
		},
	},
	["Left"] = {
		["UnitFrame"] = {
			["Enabled"] = true,
			["TooltipMode"] = "Never",
			["Scale"] = 1,
		},
		["HealthBar"] = {
			["ColourMode"] = "class",
			["ShowHealPrediction"] = true,
			["ShowAbsorb"] = true,
		},
		["HealthBarText"] = {
			["BarText"] = "%CURR_SHORT% (%PERCENT_SHORT%%)",
			["FontObject"] = "ArenaLiveFont_StatusBarTextSmall",
			["ShowDeadOrGhost"] = nil,
			["ShowDisconnect"] = true,
		},
		["PowerBar"] = {
		},
		["PowerBarText"] = {
			["BarText"] = "%CURR_SHORT% (%PERCENT_SHORT%%)",
			["FontObject"] = "ArenaLiveFont_StatusBarTextSmall",
		},
		["Portrait"] = {
			["Type"] = "class",
		},
		["NameText"] = {
			["ColourMode"] = "none",
			["FontObject"] = "ArenaLiveFont_Name",
		},
		["CCIndicator"] = {
			["Enabled"] = true,
		},
		["CastBar"] = {
			["Enabled"] = true,
		},
		["CooldownTracker"] = {
			["GrowingDirection"] = "RIGHT",
			["MaxShownIcons"] = 9,
			["ShowTrinket"] = true,
			["ShowRacial"] = true,
			["numMaxDefCDs"] = 3,
			["numMaxOffCDs"] = 3,
			["ShowTooltip"] = true,
			["Space"] = 3,
		},
		["CastHistory"] = {
			["Enabled"] = true,
			["Size"] = 18,
			["Direction"] = "RIGHT",
			["IconDuration"] = 7,
			["MaxIcons"] = 4,
		},
		["Aura"] = {
			["Enabled"] = true,
			["MaxShownBuffs"] = 8,
			["MaxShownDebuffs"] = 16,
			["AurasPerRow"] = 8,
			["NormalIconSize"] = 20,
			["LargeIconSize"] = 20,
			["GrowRTL"] = false,
			["GrowUpwards"] = false,
			["ShowOnlyPlayerDebuffs"] = false,
			["OnlyShowRaidBuffs"] = false,
			["OnlyShowDispellableDebuffs"] = false,
			["SpectatorFilter"] = true,
		},
	},
	["Right"] = {
		["UnitFrame"] = {
			["Enabled"] = true,
			["TooltipMode"] = "Never",
			["Scale"] = 1,
		},
		["HealthBar"] = {
			["ColourMode"] = "class",
			["ShowHealPrediction"] = true,
			["ShowAbsorb"] = true,
		},
		["HealthBarText"] = {
			["BarText"] = "%CURR_SHORT% (%PERCENT_SHORT%%)",
			["FontObject"] = "ArenaLiveFont_StatusBarTextSmall",
			["ShowDeadOrGhost"] = nil,
			["ShowDisconnect"] = true,
		},
		["PowerBar"] = {
		},
		["PowerBarText"] = {
			["BarText"] = "%CURR_SHORT% (%PERCENT_SHORT%%)",
			["FontObject"] = "ArenaLiveFont_StatusBarTextSmall",
			["BarTextSize"] = 10,
		},
		["Portrait"] = {
			["Type"] = "class",
		},
		["NameText"] = {
			["ColourMode"] = "none",
			["FontObject"] = "ArenaLiveFont_Name",
		},
		["CCIndicator"] = {
			["Enabled"] = true,
		},
		["CastBar"] = {
			["Enabled"] = true,
		},		
		["CooldownTracker"] = {
			["GrowingDirection"] = "LEFT",
			["MaxShownIcons"] = 9,
			["ShowTrinket"] = true,
			["ShowRacial"] = true,
			["numMaxDefCDs"] = 3,
			["numMaxOffCDs"] = 3,
			["ShowTooltip"] = true,
			["Space"] = 3,
		},
		["CastHistory"] = {
			["Enabled"] = true,
			["Size"] = 18,
			["Direction"] = "LEFT",
			["IconDuration"] = 7,
			["MaxIcons"] = 4,
		},
		["Aura"] = {
			["Enabled"] = true,
			["MaxShownBuffs"] = 8,
			["MaxShownDebuffs"] = 16,
			["AurasPerRow"] = 8,
			["NormalIconSize"] = 20,
			["LargeIconSize"] = 20,
			["GrowRTL"] = true,
			["GrowUpwards"] = false,
			["ShowOnlyPlayerDebuffs"] = false,
			["OnlyShowRaidBuffs"] = false,
			["OnlyShowDispellableDebuffs"] = false,
			["SpectatorFilter"] = true,
		},
	},
	["NamePlate"] = {
		["CCIndicator"] = {
			["Enabled"] = true,
		},
		["HealthBar"] = {
			["ColourMode"] = "class",
			["ShowHealPrediction"] = false,
			["ShowAbsorb"] = true,
		},
	},
};

-- Tables that store player info during matches:
local unitCache = {};
local unitNameToInfo = {};
-- Table to store callback functions for match start:
local onMatchStartCallbackList = {};

local slashCMDs = {
	["help"] = L["Shows this info message."],
	["menu"] = L["Shows the War Game Menu"],
	["stats"] = L["Shows the Match Statistic"],
};

-- Slash Commands:
SLASH_ARENALIVESPECTATOR1, SLASH_ARENALIVESPECTATOR2 = "/alspec", "/arenalivespectator";
function SlashCmdList.ARENALIVESPECTATOR (msg, editBox )
	if ( not msg or msg == "" or msg == "menu" ) then
		ArenaLiveSpectatorWarGameMenu:Show();
	elseif ( msg == "stats" ) then
		ArenaLiveSpectatorMatchStatistic:Open();
	elseif ( msg == "help" ) then
		ArenaLive:Message(L["Available Slash Commands for ArenaLive [Spectator] are:"], "message");
		for cmd, description in pairs(slashCMDs) do
			print(string.format(L["%s: %s"], cmd, description));
		end
	end
end

-- Custom function to check if player currently is a spectator.
--[[ 
	 From Blizzard: "You can use "CommentatorGetMode()" to see if you
	 are a spectator. It should return 0 if you are not a spectator,
	 and non-zero if you are some type of spectator.  (I believe 1 and
	 2 are reserved for our internal commentator feature, so it should
	 return 3 for you)."
]]--
function IsSpectator()
	local _, instanceType = IsInInstance();
	if ( instanceType ~= "arena" and instanceType ~= "pvp" ) then
		instanceType = nil;
	elseif ( instanceType == "pvp" ) then
		instanceType = "battleground";
	end
	
	return ( CommentatorGetMode() == 3 ), instanceType;
end

function ArenaLiveSpectator:Enable(battlefieldStatusID)
	if ( self.enabled and battlefieldStatusID == self.currentStatusID ) then
		return;
	end
	
	ArenaLiveSpectatorWarGameMenu:Hide();
	UIParent:Hide();
	self:Show();
	
	self.currentStatusID = battlefieldStatusID;
	
	-- Register events:
	self:RegisterEvent("CHAT_MSG_BG_SYSTEM_NEUTRAL");
	self:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED");
	self:RegisterEvent("PLAYER_TARGET_CHANGED");
	self:RegisterEvent("UNIT_PET");
	self:RegisterEvent("UNIT_AURA");
	self:RegisterEvent("WORLD_STATE_UI_TIMER_UPDATE");
	
	local database = ArenaLive:GetDBComponent(addonName);
	self:SetNumPlayers(database.PlayMode);
	ArenaLiveSpectatorHideUIButton:Show();
	ArenaLiveSpectatorMatchStatistic:SetParent("ArenaLiveSpectator");
	self:CallOnMatchStart(function() ArenaLiveSpectatorMatchStatistic:Start(); end, "ArenaLiveSpectatorMatchStatistic:Start()");
	ArenaLiveSpectatorMatchStatistic.leaveButton:Enable();
	
	self:CheckIfTeamsSwapped();
	
	self.enabled = true;
end

function ArenaLiveSpectator:Disable()
	self:Hide();
	ArenaLiveSpectatorHideUIButton:Hide();
	UIParent:Show();
	
	ArenaLiveSpectatorScoreBoard:Reset();
	ArenaLiveSpectatorMatchStatistic.leaveButton:Disable();
	ArenaLiveSpectatorMatchStatistic:SetParent("UIParent");
	if ( ArenaLiveSpectatorMatchStatistic:IsRecording() ) then
		ArenaLiveSpectatorMatchStatistic:Stop();
	end
	
	-- Unregister events:
	self:UnregisterEvent("CHAT_MSG_BG_SYSTEM_NEUTRAL");
	self:UnregisterEvent("COMBAT_LOG_EVENT_UNFILTERED");
	self:UnregisterEvent("PLAYER_TARGET_CHANGED");
	self:UnregisterEvent("UNIT_PET");
	self:UnregisterEvent("UNIT_AURA");
	self:UnregisterEvent("WORLD_STATE_UI_TIMER_UPDATE");	
	
	-- Disable Side frames:
	local frame;
	for i = 1, 5 do
		-- Disable Side frames:
		frame = _G["ALSPEC_LeftSideFramesFrame"..i];
		frame:Disable();
		frame = _G["ALSPEC_RightSideFramesFrame"..i];
		frame:Disable();
		
		-- Disable Cooldown Trackers:
		frame = _G["ALSPEC_CDTrackersLeftTracker"..i];
		frame:Disable();
		frame = _G["ALSPEC_CDTrackersRightTracker"..i];
		frame:Disable();
	end
	
	-- Disable Target and Target of Target:
	frame = _G["ALSPEC_TargetFrame"];
	frame:Disable();
	
	frame = _G["ALSPEC_TargetTargetFrame"];
	frame:Disable();
	
	self.leftLeader = nil;
	self.swapTeamNames = nil;
	self.currentStatusID = nil;
	self.hasStarted = nil;
	self.worldStateTimerIndex = nil;
	self.enabled = false;
end

function ArenaLiveSpectator:IsEnabled()
	return self.enabled;
end

function ArenaLiveSpectator:HasMatchStarted()
	--ArenaLive:Message("Called ArenaLiveSpectator:HasMatchStarted(): self.hasStared = %s", "debug", tostring(self.hasStarted));
	return self.hasStarted;
end

function ArenaLiveSpectator:CallOnMatchStart(callbackFunc, funcName)
	--ArenaLive:Message(L["ArenaLiveSpectator:CallOnMatchStart(): %s: %s"], "debug", tostring(funcName), tostring(callbackFunc));
	if ( not self:HasMatchStarted() ) then
		onMatchStartCallbackList[callbackFunc] = funcName or true;
	else
		callbackFunc();
	end
end

function ArenaLiveSpectator:CheckIfTeamsSwapped()
	if ( self.leftLeader and not self.swapTeamNames ) then
		local _, _, _, _, teamID = ArenaLiveSpectator.UnitCache:GetUnitInfoByName(self.leftLeader);
		if ( teamID == 0 ) then
			self.swapTeamNames = true;
			
			-- Update scoreboard display:
			ArenaLiveSpectatorScoreBoard:UpdateTeamName("TeamA");
			ArenaLiveSpectatorScoreBoard:UpdateTeamScore("TeamA");
			ArenaLiveSpectatorScoreBoard:UpdateTeamName("TeamB");
			ArenaLiveSpectatorScoreBoard:UpdateTeamScore("TeamB");
			
			if ( IsAddOnLoaded("BGLive") ) then
				BGLiveScoreBoard:UpdateTeamName("TeamA");
				BGLiveScoreBoard:UpdateTeamScore("TeamA");
				BGLiveScoreBoard:UpdateTeamName("TeamB");
				BGLiveScoreBoard:UpdateTeamScore("TeamB");
			end
		end
		
		ArenaLive:Message("ArenaLiveSpectator:CheckIfTeamsSwapped(): self.leftLeader = %s, self.swapTeamNames = %s, teamID = %s", "debug", tostring(self.leftLeader), tostring(self.swapTeamNames), tostring(teamID));
	elseif ( not self.leftLeader ) then
		self.swapTeamNames = nil;
	end
	
	return self.swapTeamNames;
end

function ArenaLiveSpectator:SetLeftLeaderName(name)
	ArenaLive:Message("Setting new left team leader: %s", "debug", name);
	self.leftLeader = name;
	self:CheckIfTeamsSwapped();
end

function ArenaLiveSpectator:PlayerUpdate()
	ArenaLiveSpectator:UpdateSideFrames();
	ArenaLiveSpectator:UpdateCooldownTrackers();
end

function ArenaLiveSpectator:SetNumPlayers(numPlayers)
	ArenaLiveSpectator:SetUpSideFrames(numPlayers);
	ArenaLiveSpectator:SetUpTargetFrames(numPlayers);
	ArenaLiveSpectator:SetUpCooldownTracker(numPlayers);
end

function ArenaLiveSpectator:OnEvent(event, ...)
	local filter = ...;
	if ( event == "ADDON_LOADED" and filter == addonName ) then
		-- Initialise Nickname Database:
		self.NicknameDatabase:Initialise()
		
		-- Initialise frames:
		self:InitialiseSideFrames();
		self:InitialiseTargetFrames();
		self:InitialiseCooldownTracker();
		ArenaLiveSpectatorScoreBoard:Initialise();
		ArenaLiveSpectatorMatchStatistic:Initialise();
		ArenaLiveSpectatorWarGameMenu:Initialise();
		ArenaLive:ConstructHandlerObject(ArenaLiveSpectatorMessageFrame, "ImportantMessageFrame", addonName, nil);
		
		-- Set up hide normal UI button, it shows up if UIParent is somehow shown during a match:
		ArenaLiveSpectatorHideUIButtonText:SetText(L["Hide normal UI"]);
		local width = ArenaLiveSpectatorHideUIButtonText:GetWidth();
		width = width + 30;
		ArenaLiveSpectatorHideUIButton:SetWidth(width);
		ArenaLiveSpectatorHideUIButton:SetScript("OnClick", ArenaLiveSpectatorHideUIButton.OnClick);
		
		-- Register addon prefix for receiving team data broadcasts:
		local success = RegisterAddonMessagePrefix("ALSPEC");
		if ( not success ) then
			ArenaLive:Message(L["WARNING! Couldn't register addon message prefix for ArenaLive [Spectator]. You won't be able to receive broadcast data during this session."], "message");
		end
		
		self:Disable();
		ArenaLive:Message(L["Spectator addon has been loaded successfully! Type /alspec to open the spectator war game menu or /alspec help for a list of available commands."], "message");
	elseif ( event == "AL_SPEC_MATCH_START" ) then
		-- Iterate through all callback functions that have registered for match start:
		ArenaLive:Message("Match begins, iterating through callbacks:", "debug");
		for callbackFunc, funcName in pairs(onMatchStartCallbackList) do
			ArenaLive:Message(L["%s: %s"], "debug", funcName, tostring(callbackFunc));
			callbackFunc();
			onMatchStartCallbackList[callbackFunc] = nil;
		end
	elseif ( event == "AL_SPEC_PLAYER_UPDATE" ) then
		ArenaLiveSpectator:PlayerUpdate();
		ArenaLiveSpectator:CheckIfTeamsSwapped();
	elseif ( event == "BN_FRIEND_TOON_ONLINE" or event == "BN_TOON_NAME_UPDATED" or event == "BN_FRIEND_TOON_OFFLINE" or event == "BN_FRIEND_LIST_SIZE_CHANGED" ) then
		-- BN_TOON_NAME_UPDATED: Args seem to be: toonID, toonName, unknown(boolean)
		self.NicknameDatabase:OnToonNameUpdate(filter);
		ArenaLiveSpectatorWarGameMenu:BNFriendEvent();
	elseif ( event == "CHAT_MSG_ADDON" and filter == "ALSPEC" ) then
		local prefix, message, channel, sender = ...;
		local playerName = UnitName("player");
		local realmName = GetRealmName();
		playerName = playerName.."-"..realmName;
		if ( sender == playerName ) then
			return;
		end

		ArenaLive:Message(L["Received team data from group leader (%s). Updating team entries..."], "normal", sender);
		
		local leftLeader, leftTeamName, leftTeamScore, rightTeamName, rightTeamScore = string.split(";", message);
		ArenaLive:Message("CHAT_MSG_ADDON: leftLeader = %s, leftTeamName = %s, leftTeamScore = %s, rightTeamName = %s, rightTeamScore = %s", "debug", leftLeader, leftTeamName, leftTeamScore, rightTeamName, rightTeamScore);
		local database = ArenaLive:GetDBComponent(addonName);
		database.TeamA.Name = leftTeamName;
		database.TeamA.Score = tonumber(leftTeamScore);
		database.TeamB.Name = rightTeamName;
		database.TeamB.Score = tonumber(rightTeamScore);

		ArenaLiveSpectator:SetLeftLeaderName(leftLeader);
		
		-- Update option frames:
		ArenaLiveSpectatorWarGameMenuWarGamesLeftTeamName:UpdateShownValue();
		ArenaLiveSpectatorWarGameMenuWarGamesLeftTeamScore:UpdateShownValue();
		ArenaLiveSpectatorWarGameMenuWarGamesRightTeamName:UpdateShownValue();
		ArenaLiveSpectatorWarGameMenuWarGamesRightTeamScore:UpdateShownValue();
		
		if ( not ArenaLiveSpectator:CheckIfTeamsSwapped() ) then
			-- Update scoreboard display:
			ArenaLiveSpectatorScoreBoard:UpdateTeamName("TeamA");
			ArenaLiveSpectatorScoreBoard:UpdateTeamScore("TeamA");
			ArenaLiveSpectatorScoreBoard:UpdateTeamName("TeamB");
			ArenaLiveSpectatorScoreBoard:UpdateTeamScore("TeamB");
				
			if ( IsAddOnLoaded("BGLive") ) then
				BGLiveScoreBoard:UpdateTeamName("TeamA");
				BGLiveScoreBoard:UpdateTeamScore("TeamA");
				BGLiveScoreBoard:UpdateTeamName("TeamB");
				BGLiveScoreBoard:UpdateTeamScore("TeamB");
			end
		end
	elseif ( event == "CHAT_MSG_BG_SYSTEM_NEUTRAL" and self.enabled ) then
		local seconds = string.match(filter, L["(.+) seconds until the Arena battle begins!"]);
		if ( seconds ) then
			local numSeconds; 
			if ( seconds == L["Thirty"] ) then
				numSeconds = 30;
			elseif ( seconds == L["Fifteen"] ) then
				numSeconds = 15;
			end
			
			if ( numSeconds ) then
				ArenaLiveSpectatorCountDown:SetTimer(numSeconds, 60);
			end
		elseif ( filter == L["One minute until the Arena battle begins!"] ) then
			ArenaLiveSpectatorCountDown:SetTimer(60, 60);
		elseif ( filter == L["The Arena battle has begun!"] ) then
			ArenaLiveSpectatorCountDown:SetTimer(0, 60);
		end
	elseif ( event == "COMBAT_LOG_EVENT_UNFILTERED" ) then
		ArenaLiveSpectatorMatchStatistic:OnEvent(event, ...)
	elseif ( event == "PLAYER_ENTERING_WORLD" ) then
		if ( BNFeaturesEnabled() and BNConnected() ) then
			ArenaLiveSpectatorWarGameMenu:UpdateNumPlayers();
			self.NicknameDatabase:InitialiseNicknames();
			self:UnregisterEvent("PLAYER_ENTERING_WORLD");
		end
	elseif ( event == "PLAYER_TARGET_CHANGED" and self.enabled ) then
		local database = ArenaLive:GetDBComponent(addonName);
		if ( database.FollowTarget ) then
			CommentatorFollowUnit("target");
		end
		if ( database.HideTargetFrames or database.PlayMode > 3 ) then
			for i = 1, database.PlayMode do
				local frame = _G["ALSPEC_LeftSideFramesFrame"..i];
				ArenaLiveSpectator:UpdateSideFrameAppearance(frame);
				frame = _G["ALSPEC_RightSideFramesFrame"..i];
				ArenaLiveSpectator:UpdateSideFrameAppearance(frame);
			end
		end
	elseif ( event == "UI_SCALE_CHANGED" or event == "DISPLAY_SIZE_CHANGED" ) then
		local screenHeight = math.ceil(GetScreenHeight());
		local scale = 786 / screenHeight;
		ArenaLiveSpectatorTooltip:SetScale(scale);
	elseif ( event == "UNIT_PET" or event == "UNIT_AURA" ) then
		ArenaLiveSpectatorMatchStatistic:OnEvent(event, ...);
	elseif ( event == "UPDATE_BATTLEFIELD_STATUS" ) then
		local status = GetBattlefieldStatus(filter);
		local winner = GetBattlefieldWinner();
		local isSpectator, gameType  = IsSpectator();
		
		ArenaLive:Message("%s: GetBattlefieldWinner(): %s, status: %s, teamSize = %d, self:HasMatchStarted() = %s, queueType = %s", "debug", event, tostring(winner), tostring(status), teamSize, tostring(ArenaLiveSpectator:HasMatchStarted()), tostring(queueType));
		
		-- Note: Since teamSize doesn't return
		-- the "correct" value in Wargames
		-- (i.e. 0 for BG and 2,3,5 for Arenas),
		-- I need to use ArenaLive's PlayMode value.		
		local database = ArenaLive:GetDBComponent(addonName);
		if ( status == "active" and filter == self.currentStatusID and winner ) then
			-- Update team scores according to winner:
			local database = ArenaLive:GetDBComponent(addonName);
			if ( ( winner == 1 and self.swapTeamNames ) or winner == 0 ) then
				database.TeamB.Score = database.TeamB.Score + 1;
			elseif ( ( winner == 0 and self.swapTeamNames ) or winner == 1 ) then
				database.TeamA.Score = database.TeamA.Score + 1;
			elseif ( winner == 255 ) then
				database.TeamA.Score = database.TeamA.Score + 1;
				database.TeamB.Score = database.TeamB.Score + 1;
			end
				
			ArenaLiveSpectatorScoreBoard:UpdateTeamScore("TeamA");
			ArenaLiveSpectatorScoreBoard:UpdateTeamScore("TeamB");
			ArenaLiveSpectatorWarGameMenuWarGamesLeftTeamScore:UpdateShownValue();
			ArenaLiveSpectatorWarGameMenuWarGamesRightTeamScore:UpdateShownValue();
				
			-- Stop Recording Match Statistic and Show it:
			ArenaLiveSpectatorMatchStatistic:Stop();
			ArenaLiveSpectatorMatchStatistic:Open(true);
		elseif ( status == "active" and isSpectator and gameType == "arena" ) then
			ArenaLiveSpectator:Enable(filter);
		elseif ( status == "active" and isSpectator and gameType == "battleground" and not IsAddOnLoaded("BGLive") ) then
				ArenaLive:Message(L["Joined a spectated battleground. Displaying a spectator UI in spectated battlegrounds requires BGLive."]);
		elseif ( status == "none" and filter == self.currentStatusID ) then
			ArenaLiveSpectator:Disable();
		end
	elseif ( event == "WORLD_STATE_UI_TIMER_UPDATE" ) then
		if ( not self.worldStateTimerIndex ) then
			for index = 1, GetNumWorldStateUI() do
				local uiType = GetWorldStateUIInfo(index);
				if ( uiType == 3 ) then -- 3 seems to be the identifier for timers.
					self.worldStateTimerIndex = index;
					break;
				end
			end
		end
			
		if ( self.worldStateTimerIndex ) then
			local uiType, state, _, text = GetWorldStateUIInfo(self.worldStateTimerIndex);
			local minutes, seconds = string.match(text,("([0-9]+):([0-9]+)$"));
				
			local minNum, secNum = tonumber(minutes), tonumber(seconds);
			if ( minNum + secNum > 0 and not self.hasStarted ) then
				ArenaLive:TriggerEvent("AL_SPEC_MATCH_START");
				self.hasStarted = true;
			end
			
			if ( ArenaLiveSpectatorScoreBoard.enabled ) then
				if ( state ) then
					ArenaLiveSpectatorScoreBoard:UpdateTimer(minutes, seconds)
				else
					ArenaLiveSpectatorScoreBoard:UpdateTimer("00", "00")
				end
			end
		end
	end
end

function ArenaLiveSpectator:UpdateDB()
	
	local database = ArenaLive:GetDBComponent(addonName);
	if ( not database.Version ) then
		database.version = nil;
		
		for frameGroup, frameGroupOptions in pairs(database) do
			if ( type(frameGroupOptions) == "table" ) then
				if ( type(frameGroupOptions.NameText) == "table" ) then
					database[frameGroup].NameText.Size = nil;
					database[frameGroup].NameText.FontObject = "ArenaLiveFont_Name";
				end
				
				if ( type(frameGroupOptions.HealthBarText) == "table" ) then
					database[frameGroup].HealthBarText.BarTextSize = nil;
					database[frameGroup].HealthBarText.FontObject = "ArenaLiveFont_StatusBarTextSmall";
				end
				
				if ( type(frameGroupOptions.PowerBarText) == "table" ) then
					database[frameGroup].PowerBarText.BarTextSize = nil;
					database[frameGroup].PowerBarText.FontObject = "ArenaLiveFont_StatusBarTextSmall";
				end
			end
		end
		
		database.Version = "3.0.0b";
	end
	
	if ( database.Version == "3.0.0b" ) then
		database.Version = "3.1.0b";
	end
end

function ArenaLiveSpectatorHideUIButton:OnClick(button, down)
	if( button == "LeftButton" ) then
		UIParent:Hide();
	end
end

ArenaLive:ConstructAddon(ArenaLiveSpectator, addonName, true, ArenaLiveSpectator.defaults, false, "ALSPEC_Database");
ArenaLiveSpectator:RegisterEvent("AL_SPEC_PLAYER_UPDATE"); -- Custom Event triggered by UnitCache handler.
ArenaLiveSpectator:RegisterEvent("AL_SPEC_MATCH_START"); -- Custom Event triggered by ArenaLiveSpectator:OnEvent() WORLD_STATE_UI_TIMER_UPDATE
ArenaLiveSpectator:RegisterEvent("ADDON_LOADED");
ArenaLiveSpectator:RegisterEvent("BN_FRIEND_LIST_SIZE_CHANGED");
ArenaLiveSpectator:RegisterEvent("BN_FRIEND_TOON_ONLINE");
ArenaLiveSpectator:RegisterEvent("BN_TOON_NAME_UPDATED");
ArenaLiveSpectator:RegisterEvent("BN_FRIEND_TOON_OFFLINE");
ArenaLiveSpectator:RegisterEvent("CHAT_MSG_ADDON");
ArenaLiveSpectator:RegisterEvent("DISPLAY_SIZE_CHANGED");
ArenaLiveSpectator:RegisterEvent("PLAYER_ENTERING_WORLD");
ArenaLiveSpectator:RegisterEvent("UI_SCALE_CHANGED");
ArenaLiveSpectator:RegisterEvent("UPDATE_BATTLEFIELD_STATUS");